﻿Imports System.Linq
Imports System.Collections
Imports System.Collections.Generic
Imports System.Data
Imports System.Runtime.CompilerServices
Imports System.ComponentModel
Namespace System.Windows.Forms

   Public Class TypedRowHelper(Of T As DataRow)

      Default Public ReadOnly Property Item(bs As BindingSource) As T
         Get
            Return bs.At(Of T)()
         End Get
      End Property
      Default Public ReadOnly Property Item(bs As BindingSource, indx As Integer) As T
         Get
            Return bs.At(Of T)(indx)
         End Get
      End Property
      Default Public ReadOnly Property Item(itm As Object) As T
         Get
            Return DirectCast(DirectCast(itm, DataRowView).Row, T)
         End Get
      End Property
      Default Public ReadOnly Property Item(dgv As DataGridView) As T
         Get
            Return DirectCast(DirectCast(dgv.CurrentRow.DataBoundItem, DataRowView).Row, T)
         End Get
      End Property
      Default Public ReadOnly Property Item(dgv As DataGridView, indx As Integer) As T
         Get
            Return DirectCast(DirectCast(dgv.Rows(indx).DataBoundItem, DataRowView).Row, T)
         End Get
      End Property
      Public ReadOnly Iterator Property SelectedDataRows(dgv As DataGridView) As IEnumerable(Of T)
         Get
            For Each rw As DataGridViewRow In dgv.SelectedRows
               Yield(DirectCast(DirectCast(rw.DataBoundItem, DataRowView).Row, T))
            Next
         End Get
      End Property

   End Class

End Namespace
