﻿Imports System.Windows.Forms
Imports DataModel.PersonBerufDts

Public Class frmTwoLayerArchitecture

   Public Sub New()
      InitializeComponent()
      Dts.Register(Me).DataFile("..\..\..\DataModel\PersoBerufDts.Xml").Fill()
   End Sub

   Private Sub btReLoad_Click(sender As Object, e As EventArgs) Handles btReLoad.Click
      Reload()
   End Sub

   Private Sub Reload()
      Dts.Fill()
   End Sub

   Private Sub btEditNew_Click(sender As Object, e As EventArgs) Handles btEditNew.Click
      With Dts.Person
         Dim values = TupleList.From(Of DataColumn, Object)(.NameColumn, NameTextBox.Text)(.BirthColumn, BirthDateTimePicker.Value)
         If bsPerson.EditNew(Of dlgPerson)(values, Me) <> Windows.Forms.DialogResult.OK Then
            'fein
         Else
            'auch fein
         End If

      End With
   End Sub

   Private Sub dgvPerson_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvPerson.CellDoubleClick
      bsPerson.EditCurrent(Of dlgPerson)()
   End Sub

   Private Sub btSave_Click(sender As Object, e As EventArgs) Handles btSave.Click
      Dts.Save(Me)
   End Sub
End Class
